/*oracle*/
CREATE VIEW v_act_waittasklist AS SELECT
	A.ID_ AS TASK_ID,
	A.PROC_INST_ID_ PROC_INST_ID,
	A.TASK_DEF_KEY_ AS ACT_ID,
	A.NAME_ AS ACT_NAME,
	A.ASSIGNEE_ AS ASSIGNEE,
	A.DELEGATION_ AS DELEGATION_ID,
	A.DESCRIPTION_ AS DESCRIPTION,
	TO_CHAR (
		A.CREATE_TIME_,
		'YYYY-MM-DD HH24:MI:SS'
	) AS CREATE_TIME,
	TO_CHAR (
		A.DUE_DATE_,
		'YYYY-MM-DD HH24:MI:SS'
	) AS DUE_DATE,
	I.USER_ID CANDIDATE
FROM
	ACT_RU_TASK A
LEFT JOIN (
	SELECT DISTINCT
		*
	FROM
		(
			SELECT
				TASK_ID_,
				TO_CHAR (USER_ID_) USER_ID
			FROM
				ACT_RU_IDENTITYLINK I,
				ACT_RU_TASK T
			WHERE
				TASK_ID_ IS NOT NULL
			AND USER_ID_ IS NOT NULL
			AND I.TASK_ID_ = T.ID_
			AND T.ASSIGNEE_ IS NULL
			AND TYPE_ = 'candidate'
			UNION
				SELECT
					TASK_ID_,
					R.USER_ID
				FROM
					ACT_RU_IDENTITYLINK I,
					SYS_ROLE_USER R,
					ACT_RU_TASK T
				WHERE
					I.TASK_ID_ IS NOT NULL
				AND I.GROUP_ID_ IS NOT NULL
				AND I.TASK_ID_ = T.ID_
				AND T.ASSIGNEE_ IS NULL
				AND TYPE_ = 'candidate'
				AND I.GROUP_ID_ = R.ROLE_ID
		) U
) I -- 候选组和业务上的角色用户表关联 ON A.ID_ = I.TASK_ID_


/*mysql*/
CREATE VIEW v_act_waittasklist AS SELECT
	A.ID_ AS TASK_ID,
	A.PROC_INST_ID_ PROC_INST_ID,
	A.TASK_DEF_KEY_ AS ACT_ID,
	A.NAME_ AS ACT_NAME,
	A.ASSIGNEE_ AS ASSIGNEE,
	A.DELEGATION_ AS DELEGATION_ID,
	A.DESCRIPTION_ AS DESCRIPTION,
	-- A.CREATE_TIME_ AS CREATE_TIME,
	-- A.DUE_DATE_ AS DUE_DATE,
	date_format(
		A.CREATE_TIME_,
		'%Y-%m-%d %H:%i:%S'
	) AS CREATE_TIME,
	date_format(
		A.DUE_DATE_,
		'%Y-%m-%d %H:%i:%S'
	) AS DUE_DATE,
	I.USER_ID AS CANDIDATE
FROM
	ACT_RU_TASK A
LEFT JOIN (
	SELECT DISTINCT
		*
	FROM
		(
			SELECT
				I.TASK_ID_,
				I.USER_ID_ AS USER_ID
			FROM
				ACT_RU_IDENTITYLINK I,
				ACT_RU_TASK T
			WHERE
				TASK_ID_ IS NOT NULL
			AND USER_ID_ IS NOT NULL
			AND I.TASK_ID_ = T.ID_
			AND T.ASSIGNEE_ IS NULL
			AND TYPE_ = 'candidate'
			UNION
				SELECT
					TASK_ID_,
					I.GROUP_ID_ AS USER_ID
				FROM
					ACT_RU_IDENTITYLINK I,
					ACT_RU_TASK T
				WHERE
					I.TASK_ID_ IS NOT NULL
				AND I.GROUP_ID_ IS NOT NULL
				AND I.TASK_ID_ = T.ID_
				AND T.ASSIGNEE_ IS NULL
				AND I.TYPE_ = 'candidate'
		) U
) I -- 候选组和业务上的角色用户表关联
ON A.ID_ = I.TASK_ID_

-- 示例
SELECT * FROM  v_act_waittasklist WHERE ASSIGNEE = '11' OR CANDIDATE = 'user2,admin'

